

Summary:        A free h264/avc encoder - encoder binary
Name:           x264
Version:        1.148
Release:        %mkrel 2
License:        GNU General Public License (GPL)
Group:          Video
URL:            http://developers.videolan.org/x264.html
Source0:        %{name}-%{version}.tar.xz
Source1:		x264-1.138.tar.xz
Source2:		x264-0.115.tar.xz
Patch1:			x264-use-upstream-opt-level.diff
Patch2:			x264-gpac-link.patch
BuildRoot:      %{_tmppath}/build-root-%{name}
BuildRequires:  gpac-devel git
BuildRequires:  yasm >= 0.7.1
BuildRequires:	%{_lib}ffmpeg-devel


%description 
x264 is a free library for encoding next-generation H264/AVC video
streams. The code is written from scratch by Laurent Aimar, Loren
Merritt, Eric Petit (OS X), Min Chen (vfw/asm), Justin Clay (vfw), Mans
Rullgard, Radek Czyz, Christian Heine (asm), Alex Izvorski (asm), and
Alex Wright. It is released under the terms of the GPL license. This
package contains a shared library and a commandline tool for encoding
H264 streams. 

Encoder features:
- CAVLC/CABAC
- Multi-references
- Intra: all macroblock types (16x16, 8x8, and 4x4 with all predictions)
- Inter P: all partitions (from 16x16 down to 4x4)
- Inter B: partitions from 16x16 down to 8x8 (including skip/direct)
- Ratecontrol: constant quantizer, single or multipass ABR, optional VBV
- Scene cut detection
- Adaptive B-frame placement
- B-frames as references / arbitrary frame order
- 8x8 and 4x4 adaptive spatial transform
- Lossless mode
- Custom quantization matrices
- Parallel encoding of multiple slices (currently disabled)


%package devel
Summary:        Libraries and include file for the x264 encoder
Group:          Development/Libraries/C and C++
Requires:       %{name} = %{version}-%{release}

%description devel
x264 is a free library for encoding next-generation H264/AVC video
streams. The code is written from scratch by Laurent Aimar, Loren
Merritt, Eric Petit (OS X), Min Chen (vfw/asm), Justin Clay (vfw), Mans
Rullgard, Radek Czyz, Christian Heine (asm), Alex Izvorski (asm), and
Alex Wright. It is released under the terms of the GPL license. 
Development files.

%package static-devel
Summary:        Static library for the x264 encoder
Group:          Development/Libraries/C and C++
Requires:	%name-devel

%description static-devel
Static library for x264

%prep
%setup -q -n %{name}-%{version} -a1 -a2
perl -pi -e 's|usr/local|usr||g' configure
%patch1 -p0
%patch2 -p1 -b .gpac-link

%build
%configure2_5x --enable-shared \
	       --enable-pic \
	       --enable-visualize \
	       --enable-static

%make 

cd x264-1.138
%configure2_5x --enable-shared \
	       --enable-pic \
	       --enable-visualize \
	       --enable-static \

%make
cd ..

#This is a hacky solution for now. The old x264 library doesn't build with ffmpeg 2.0 so
#lets remove it. You will need to re-install after building

%ifarch %{ix86}
rpm -e --nodeps libffmpeg-devel
%else
rpm -e --nodeps lib64ffmpeg-devel
%endif

cd x264-0.115
%configure2_5x --enable-shared \
	       --enable-pic \
	       --enable-visualize \
	       --enable-static \
		
%make 

cd ..

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p %{buildroot}%{_libdir}

install -m 0755 x264-1.138/libx264.so.138 %{buildroot}%{_libdir}
install -m 0755 x264-0.115/libx264.so.115 %{buildroot}%{_libdir}

%makeinstall


%clean
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files
%defattr(-,root,root)
%doc AUTHORS COPYING
%{_bindir}/x264
%{_libdir}/libx264.so.*

%files devel
%defattr(-,root,root)
%{_libdir}/pkgconfig/x264.pc
%{_includedir}/x264.h
%{_includedir}/x264_config.h
%{_libdir}/libx264.so

%files static-devel
%defattr(-,root,root)
%{_libdir}/libx264.a


%changelog
* Wed Mar 08 2017 bb2 <bb2> - 1.148-2pclos2017
- rebuild for new ffmpeg

* Sat Apr 16 2016 bb <bb> 1.148-1pclos2016
- update 

* Mon Nov 16 2014 bb <bb> 1.138-5pclos2014
- rebuild ffmpeg 2.4.3

* Fri Dec 14 2013 bb <bb> 1.138-4pclos2013
- drop bit-depth=10 back to default

* Wed Dec 11 2013 bb <bb> 1.138-3pclos2013
- enable bit-depth=10

